Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 1004)
@@ -118,23 +118,23 @@
 mRenderSimulator(NULL)
 {
-	environment->GetBoolValue("Preprocessor.useGlRenderer", mUseGlRenderer);
+	Environment::GetSingleton()->GetBoolValue("Preprocessor.useGlRenderer", mUseGlRenderer);
   
 	// renderer will be constructed when the scene graph and viewcell manager will be known
 	renderer = NULL;
   
-	environment->GetBoolValue("Preprocessor.useGlDebugger", mUseGlDebugger);
-	environment->GetBoolValue("Preprocessor.loadPolygonsAsMeshes", mLoadPolygonsAsMeshes);
-	environment->GetBoolValue("Preprocessor.quitOnFinish", mQuitOnFinish);
-	environment->GetBoolValue("Preprocessor.computeVisibility", mComputeVisibility);
-	environment->GetBoolValue("Preprocessor.detectEmptyViewSpace", mDetectEmptyViewSpace);
-	environment->GetBoolValue("Preprocessor.exportVisibility", mExportVisibility );
+	Environment::GetSingleton()->GetBoolValue("Preprocessor.useGlDebugger", mUseGlDebugger);
+	Environment::GetSingleton()->GetBoolValue("Preprocessor.loadPolygonsAsMeshes", mLoadPolygonsAsMeshes);
+	Environment::GetSingleton()->GetBoolValue("Preprocessor.quitOnFinish", mQuitOnFinish);
+	Environment::GetSingleton()->GetBoolValue("Preprocessor.computeVisibility", mComputeVisibility);
+	Environment::GetSingleton()->GetBoolValue("Preprocessor.detectEmptyViewSpace", mDetectEmptyViewSpace);
+	Environment::GetSingleton()->GetBoolValue("Preprocessor.exportVisibility", mExportVisibility );
 
 	char buffer[256];
-	environment->GetStringValue("Preprocessor.visibilityFile",  buffer);
+	Environment::GetSingleton()->GetStringValue("Preprocessor.visibilityFile",  buffer);
 	mVisibilityFileName = buffer;
-	environment->GetBoolValue("Preprocessor.applyVisibilityFilter", mApplyVisibilityFilter );
-	environment->GetBoolValue("Preprocessor.applyVisibilitySpatialFilter",
+	Environment::GetSingleton()->GetBoolValue("Preprocessor.applyVisibilityFilter", mApplyVisibilityFilter );
+	Environment::GetSingleton()->GetBoolValue("Preprocessor.applyVisibilitySpatialFilter",
 							  mApplyVisibilitySpatialFilter );
-	environment->GetFloatValue("Preprocessor.visibilityFilterWidth", mVisibilityFilterWidth);
+	Environment::GetSingleton()->GetFloatValue("Preprocessor.visibilityFilterWidth", mVisibilityFilterWidth);
 
 	Debug << "detect empty view space=" << mDetectEmptyViewSpace << endl;
@@ -361,16 +361,16 @@
 {
 	//-- parse view cells construction method
-	environment->GetBoolValue("ViewCells.loadFromFile", mLoadViewCells);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.loadFromFile", mLoadViewCells);
 	char buf[100];
 	
 	if (mLoadViewCells)
 	{	
-		environment->GetStringValue("ViewCells.filename", buf);
-		mViewCellsManager = ViewCellsManager::LoadViewCells(buf, &mObjects, environment, true);
+		Environment::GetSingleton()->GetStringValue("ViewCells.filename", buf);
+		mViewCellsManager = ViewCellsManager::LoadViewCells(buf, &mObjects, true);
 	}
 	else
 	{
 		//-- parse type of view cell container
-		environment->GetStringValue("ViewCells.type", buf);		
+		Environment::GetSingleton()->GetStringValue("ViewCells.type", buf);		
 	    mViewCellsManager = CreateViewCellsManager(buf);
 	}
@@ -379,7 +379,7 @@
 	float objRenderCost = 0, vcOverhead = 0, moveSpeed = 0;
 
-	environment->GetFloatValue("Simulation.objRenderCost",objRenderCost);
-	environment->GetFloatValue("Simulation.vcOverhead", vcOverhead);
-	environment->GetFloatValue("Simulation.moveSpeed", moveSpeed);
+	Environment::GetSingleton()->GetFloatValue("Simulation.objRenderCost",objRenderCost);
+	Environment::GetSingleton()->GetFloatValue("Simulation.vcOverhead", vcOverhead);
+	Environment::GetSingleton()->GetFloatValue("Simulation.moveSpeed", moveSpeed);
 	
 	mRenderSimulator = 
@@ -408,5 +408,5 @@
 	if (strcmp(name, "kdTree") == 0)
 	{
-		mViewCellsManager = new KdViewCellsManager(mKdTree, environment);
+		mViewCellsManager = new KdViewCellsManager(mKdTree);
 	}
 	else if (strcmp(name, "bspTree") == 0)
@@ -415,5 +415,5 @@
 
 		mBspTree = new BspTree();
-		mViewCellsManager = new BspViewCellsManager(mBspTree, environment);
+		mViewCellsManager = new BspViewCellsManager(mBspTree);
 	}
 	else if (strcmp(name, "vspBspTree") == 0)
@@ -421,6 +421,6 @@
 		Debug << "view cell type: VspBsp" << endl;
 
-		mVspBspTree = new VspBspTree(environment);
-		mViewCellsManager = new VspBspViewCellsManager(mVspBspTree, environment);
+		mVspBspTree = new VspBspTree();
+		mViewCellsManager = new VspBspViewCellsManager(mVspBspTree);
 	}
 	else if (strcmp(name, "vspKdTree") == 0)
@@ -428,5 +428,5 @@
 		mVspKdTree = new VspKdTree();		
 	
-		mViewCellsManager = new VspKdViewCellsManager(mVspKdTree, environment);
+		mViewCellsManager = new VspKdViewCellsManager(mVspKdTree);
 	}
 	else if (strcmp(name, "sceneDependent") == 0)
@@ -437,5 +437,5 @@
 		Debug << "view cell type: Bsp" << endl;
 		
-		mViewCellsManager = new BspViewCellsManager(mBspTree, environment);
+		mViewCellsManager = new BspViewCellsManager(mBspTree);
 	}
 	else
@@ -464,5 +464,5 @@
 	std::stable_sort(objects.begin(), objects.end(), ilt);
 	char fileName[100];
-	environment->GetStringValue("Preprocessor.samplesFilename", fileName);
+	Environment::GetSingleton()->GetStringValue("Preprocessor.samplesFilename", fileName);
 	
     Vector3 origin, termination;
@@ -549,5 +549,5 @@
 {
 	char fileName[100];
-	environment->GetStringValue("Preprocessor.samplesFilename", fileName);
+	Environment::GetSingleton()->GetStringValue("Preprocessor.samplesFilename", fileName);
 	
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/RenderSampler.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RenderSampler.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RenderSampler.cpp	(revision 1004)
@@ -8,5 +8,5 @@
 RenderSampler::RenderSampler():Preprocessor()
 {
-  environment->GetIntValue("RenderSampler.samples", mSamples);
+  Environment::GetSingleton()->GetIntValue("RenderSampler.samples", mSamples);
   cout << "number of render samples: " << mSamples << endl;
 }
@@ -22,8 +22,8 @@
 	bool useOcclusionQueries;
 
-    environment->GetIntValue("Preprocessor.histogram.maxValue", histoMaxVal);
-	environment->GetIntValue("Preprocessor.histogram.intervals", histoIntervals);
-	environment->GetIntValue("RenderSampler.visibleThreshold", threshold);
-	environment->GetBoolValue("RenderSampler.useOcclusionQueries", useOcclusionQueries);
+    Environment::GetSingleton()->GetIntValue("Preprocessor.histogram.maxValue", histoMaxVal);
+	Environment::GetSingleton()->GetIntValue("Preprocessor.histogram.intervals", histoIntervals);
+	Environment::GetSingleton()->GetIntValue("RenderSampler.visibleThreshold", threshold);
+	Environment::GetSingleton()->GetBoolValue("RenderSampler.useOcclusionQueries", useOcclusionQueries);
 
 	Debug << "************* render sampler ****************" << endl;
@@ -57,6 +57,5 @@
 		histogram[i] = 0;
 	}
-cout << "here3 "<< mSamples << endl;
-	cout << "here2 " << samples.size() << endl;
+
 	// store maximal pvs
 	for (int i = 0; i < mSamples; ++ i) 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp	(revision 884)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp	(revision 1004)
@@ -29,21 +29,21 @@
 {
   // this should increase coherence of the samples
-  environment->GetIntValue("RssPreprocessor.samplesPerPass", mSamplesPerPass);
-  environment->GetIntValue("RssPreprocessor.initialSamples", mInitialSamples);
-  environment->GetIntValue("RssPreprocessor.vssSamples", mRssSamples);
-  environment->GetIntValue("RssPreprocessor.vssSamplesPerPass", mRssSamplesPerPass);
-  environment->GetBoolValue("RssPreprocessor.useImportanceSampling", mUseImportanceSampling);
-
-  environment->GetBoolValue("RssPreprocessor.Export.pvs", mExportPvs);
-  environment->GetBoolValue("RssPreprocessor.Export.rssTree", mExportRssTree);
-  environment->GetBoolValue("RssPreprocessor.Export.rays", mExportRays);
-  environment->GetIntValue("RssPreprocessor.Export.numRays", mExportNumRays);
-  environment->GetBoolValue("RssPreprocessor.useViewcells", mUseViewcells);
-  environment->GetBoolValue("RssPreprocessor.objectBasedSampling", mObjectBasedSampling);
-  environment->GetBoolValue("RssPreprocessor.directionalSampling", mDirectionalSampling);
-
-  environment->GetBoolValue("RssPreprocessor.loadInitialSamples", mLoadInitialSamples);
-  environment->GetBoolValue("RssPreprocessor.storeInitialSamples", mStoreInitialSamples);
-  environment->GetBoolValue("RssPreprocessor.updateSubdivision", mUpdateSubdivision);
+  Environment::GetSingleton()->GetIntValue("RssPreprocessor.samplesPerPass", mSamplesPerPass);
+  Environment::GetSingleton()->GetIntValue("RssPreprocessor.initialSamples", mInitialSamples);
+  Environment::GetSingleton()->GetIntValue("RssPreprocessor.vssSamples", mRssSamples);
+  Environment::GetSingleton()->GetIntValue("RssPreprocessor.vssSamplesPerPass", mRssSamplesPerPass);
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.useImportanceSampling", mUseImportanceSampling);
+
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.Export.pvs", mExportPvs);
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.Export.rssTree", mExportRssTree);
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.Export.rays", mExportRays);
+  Environment::GetSingleton()->GetIntValue("RssPreprocessor.Export.numRays", mExportNumRays);
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.useViewcells", mUseViewcells);
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.objectBasedSampling", mObjectBasedSampling);
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.directionalSampling", mDirectionalSampling);
+
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.loadInitialSamples", mLoadInitialSamples);
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.storeInitialSamples", mStoreInitialSamples);
+  Environment::GetSingleton()->GetBoolValue("RssPreprocessor.updateSubdivision", mUpdateSubdivision);
   
   mStats.open("stats.log");
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VssPreprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VssPreprocessor.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VssPreprocessor.cpp	(revision 1004)
@@ -26,16 +26,16 @@
 {
   // this should increase coherence of the samples
-  environment->GetIntValue("VssPreprocessor.samplesPerPass", mSamplesPerPass);
-  environment->GetIntValue("VssPreprocessor.initialSamples", mInitialSamples);
-  environment->GetIntValue("VssPreprocessor.vssSamples", mVssSamples);
-  environment->GetIntValue("VssPreprocessor.vssSamplesPerPass", mVssSamplesPerPass);
-  environment->GetBoolValue("VssPreprocessor.useImportanceSampling", mUseImportanceSampling);
+  Environment::GetSingleton()->GetIntValue("VssPreprocessor.samplesPerPass", mSamplesPerPass);
+  Environment::GetSingleton()->GetIntValue("VssPreprocessor.initialSamples", mInitialSamples);
+  Environment::GetSingleton()->GetIntValue("VssPreprocessor.vssSamples", mVssSamples);
+  Environment::GetSingleton()->GetIntValue("VssPreprocessor.vssSamplesPerPass", mVssSamplesPerPass);
+  Environment::GetSingleton()->GetBoolValue("VssPreprocessor.useImportanceSampling", mUseImportanceSampling);
  
-  environment->GetBoolValue("VssPreprocessor.loadInitialSamples", mLoadInitialSamples);
-  environment->GetBoolValue("VssPreprocessor.storeInitialSamples", mStoreInitialSamples);
-  environment->GetBoolValue("VssPreprocessor.useViewSpaceBox", mUseViewSpaceBox);
-  environment->GetBoolValue("VssPreprocessor.testBeamSampling", mTestBeamSampling);
-  environment->GetBoolValue("VssPreprocessor.enlargeViewSpace", mEnlargeViewSpace);
-  environment->GetBoolValue("Preprocessor.detectEmptyViewSpace", mDetectEmptyViewSpace);
+  Environment::GetSingleton()->GetBoolValue("VssPreprocessor.loadInitialSamples", mLoadInitialSamples);
+  Environment::GetSingleton()->GetBoolValue("VssPreprocessor.storeInitialSamples", mStoreInitialSamples);
+  Environment::GetSingleton()->GetBoolValue("VssPreprocessor.useViewSpaceBox", mUseViewSpaceBox);
+  Environment::GetSingleton()->GetBoolValue("VssPreprocessor.testBeamSampling", mTestBeamSampling);
+  Environment::GetSingleton()->GetBoolValue("VssPreprocessor.enlargeViewSpace", mEnlargeViewSpace);
+  Environment::GetSingleton()->GetBoolValue("Preprocessor.detectEmptyViewSpace", mDetectEmptyViewSpace);
   
   useViewspacePlane = mUseViewSpaceBox; //hack
Index: GTP/trunk/Lib/Vis/Preprocessing/src/X3dExporter.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/X3dExporter.cpp	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/X3dExporter.cpp	(revision 1004)
@@ -737,5 +737,5 @@
 				VssRay *ray;
 				
-				const indices[][2] = {{0,0}, {0,1}, {1,1}, {1,0}}; 
+				const int indices[][2] = {{0,0}, {0,1}, {1,1}, {1,0}}; 
 				MeshInstance dummy(mesh);
 				for (int i=0; i < 4; i++) {
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SamplingPreprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SamplingPreprocessor.cpp	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SamplingPreprocessor.cpp	(revision 1004)
@@ -17,6 +17,6 @@
 {
   // this should increase coherence of the samples
-  environment->GetIntValue("Sampling.samplesPerPass", mSamplesPerPass);
-  environment->GetIntValue("Sampling.totalSamples", mTotalSamples);
+  Environment::GetSingleton()->GetIntValue("Sampling.samplesPerPass", mSamplesPerPass);
+  Environment::GetSingleton()->GetIntValue("Sampling.totalSamples", mTotalSamples);
  
   mStats.open("stats.log");
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1004)
@@ -40,5 +40,5 @@
 
 
-ViewCellsManager::ViewCellsManager(Environment *env):
+ViewCellsManager::ViewCellsManager():
 mRenderer(NULL),
 mInitialSamples(0),
@@ -53,10 +53,9 @@
 mMaxPvsRatio(1.0),
 mViewCellPvsIsUpdated(false)
-,mEnvironment(env)
 {
 	mViewSpaceBox.Initialize();
 	ParseEnvironment();
 
-	mViewCellsTree = new ViewCellsTree(this, env);
+	mViewCellsTree = new ViewCellsTree(this);
 }
 
@@ -65,9 +64,9 @@
 {
 	// visualization stuff
-	mEnvironment->GetBoolValue("ViewCells.Visualization.exportRays", mExportRays);
-	mEnvironment->GetBoolValue("ViewCells.Visualization.exportGeometry", mExportGeometry);
-	mEnvironment->GetFloatValue("ViewCells.maxPvsRatio", mMaxPvsRatio);
-	
-	mEnvironment->GetBoolValue("ViewCells.pruneEmptyViewCells", mPruneEmptyViewCells);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.Visualization.exportRays", mExportRays);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.Visualization.exportGeometry", mExportGeometry);
+	Environment::GetSingleton()->GetFloatValue("ViewCells.maxPvsRatio", mMaxPvsRatio);
+	
+	Environment::GetSingleton()->GetBoolValue("ViewCells.pruneEmptyViewCells", mPruneEmptyViewCells);
 
 	// HACK
@@ -77,30 +76,30 @@
 		mMinPvsSize = 0;
 
-	mEnvironment->GetBoolValue("ViewCells.processOnlyValidViewCells", mOnlyValidViewCells);
-
-	mEnvironment->GetIntValue("ViewCells.Construction.samples", mConstructionSamples);
-	mEnvironment->GetIntValue("ViewCells.PostProcess.samples", mPostProcessSamples);
-	mEnvironment->GetBoolValue("ViewCells.PostProcess.useRaysForMerge", mUseRaysForMerge);
-
- 	mEnvironment->GetIntValue("ViewCells.Visualization.samples", mVisualizationSamples);
-
-	mEnvironment->GetIntValue("ViewCells.Construction.samplesPerPass", mSamplesPerPass);
-	mEnvironment->GetBoolValue("ViewCells.exportToFile", mExportViewCells);
-	
-	mEnvironment->GetIntValue("ViewCells.active", mNumActiveViewCells);
-	mEnvironment->GetBoolValue("ViewCells.PostProcess.compress", mCompressViewCells);
-	mEnvironment->GetBoolValue("ViewCells.Visualization.useClipPlane", mUseClipPlaneForViz);
-	mEnvironment->GetBoolValue("ViewCells.PostProcess.merge", mMergeViewCells);
-	mEnvironment->GetBoolValue("ViewCells.evaluateViewCells", mEvaluateViewCells);
-	mEnvironment->GetBoolValue("ViewCells.showVisualization", mShowVisualization);
-	mEnvironment->GetIntValue("ViewCells.Filter.maxSize", mMaxFilterSize);
-	mEnvironment->GetFloatValue("ViewCells.Filter.width", mFilterWidth);
-	mEnvironment->GetIntValue("ViewCells.renderCostEvaluationType", mRenderCostEvaluationType);
-
-	mEnvironment->GetBoolValue("ViewCells.exportBboxesForPvs", mExportBboxesForPvs);
-	mEnvironment->GetBoolValue("ViewCells.exportPvs", mExportPvs);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.processOnlyValidViewCells", mOnlyValidViewCells);
+
+	Environment::GetSingleton()->GetIntValue("ViewCells.Construction.samples", mConstructionSamples);
+	Environment::GetSingleton()->GetIntValue("ViewCells.PostProcess.samples", mPostProcessSamples);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.PostProcess.useRaysForMerge", mUseRaysForMerge);
+
+ 	Environment::GetSingleton()->GetIntValue("ViewCells.Visualization.samples", mVisualizationSamples);
+
+	Environment::GetSingleton()->GetIntValue("ViewCells.Construction.samplesPerPass", mSamplesPerPass);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.exportToFile", mExportViewCells);
+	
+	Environment::GetSingleton()->GetIntValue("ViewCells.active", mNumActiveViewCells);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.PostProcess.compress", mCompressViewCells);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.Visualization.useClipPlane", mUseClipPlaneForViz);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.PostProcess.merge", mMergeViewCells);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.evaluateViewCells", mEvaluateViewCells);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.showVisualization", mShowVisualization);
+	Environment::GetSingleton()->GetIntValue("ViewCells.Filter.maxSize", mMaxFilterSize);
+	Environment::GetSingleton()->GetFloatValue("ViewCells.Filter.width", mFilterWidth);
+	Environment::GetSingleton()->GetIntValue("ViewCells.renderCostEvaluationType", mRenderCostEvaluationType);
+
+	Environment::GetSingleton()->GetBoolValue("ViewCells.exportBboxesForPvs", mExportBboxesForPvs);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.exportPvs", mExportPvs);
 
 	char buf[100];
-	mEnvironment->GetStringValue("ViewCells.samplingType", buf);
+	Environment::GetSingleton()->GetStringValue("ViewCells.samplingType", buf);
 
 	
@@ -119,5 +118,5 @@
 	}
 
-	mEnvironment->GetStringValue("ViewCells.Evaluation.samplingType", buf);
+	Environment::GetSingleton()->GetStringValue("ViewCells.Evaluation.samplingType", buf);
 	
 	if (strcmp(buf, "box") == 0)
@@ -135,5 +134,5 @@
 	}
 
-	mEnvironment->GetStringValue("ViewCells.renderCostEvaluationType", buf);
+	Environment::GetSingleton()->GetStringValue("ViewCells.renderCostEvaluationType", buf);
 	
 	if (strcmp(buf, "perobject") == 0)
@@ -151,5 +150,5 @@
 	}
 
-    mEnvironment->GetStringValue("ViewCells.Visualization.colorCode", buf);
+    Environment::GetSingleton()->GetStringValue("ViewCells.Visualization.colorCode", buf);
 
 	if (strcmp(buf, "PVS") == 0)
@@ -393,5 +392,5 @@
 		  << TimeDiff(startTime, GetTime()) * 1e-3 << " secs" << endl;
 
-return 0;
+//return 0;
 	// take post processing time
 	startTime = GetTime();
@@ -560,9 +559,9 @@
 
     int histoIntervals;
-	mEnvironment->GetIntValue("Preprocessor.histogram.intervals", histoIntervals);
+	Environment::GetSingleton()->GetIntValue("Preprocessor.histogram.intervals", histoIntervals);
 	const int intervals = min(histoIntervals, (int)viewCells.size());
 
 	int histoMaxVal;
-	mEnvironment->GetIntValue("Preprocessor.histogram.maxValue", histoMaxVal);
+	Environment::GetSingleton()->GetIntValue("Preprocessor.histogram.maxValue", histoMaxVal);
 	maxRenderCost = max(histoMaxVal, maxRenderCost);
 
@@ -629,5 +628,4 @@
 ViewCellsManager *ViewCellsManager::LoadViewCells(const string &filename, 
 												  ObjectContainer *objects,
-												  Environment *env,
 												  const bool finalizeViewCells,
 												  BoundingBoxConverter *bconverter)
@@ -638,5 +636,5 @@
 	ViewCellsManager *vm = NULL;
 
-	if (parser.ParseFile(filename, &vm, objects, bconverter, env))
+	if (parser.ParseFile(filename, &vm, objects, bconverter))
 	{
 		long startTime = GetTime();
@@ -762,5 +760,5 @@
 	// hack: normalize pvs size
 	int histoMaxVal;
-	mEnvironment->GetIntValue("Preprocessor.histogram.maxValue", histoMaxVal);
+	Environment::GetSingleton()->GetIntValue("Preprocessor.histogram.maxValue", histoMaxVal);
 	maxVal = max(histoMaxVal, maxPvs);
 		
@@ -768,5 +766,5 @@
 
 	int histoIntervals;
-	mEnvironment->GetIntValue("Preprocessor.histogram.intervals", histoIntervals);
+	Environment::GetSingleton()->GetIntValue("Preprocessor.histogram.intervals", histoIntervals);
 	const int intervals = min(histoIntervals, (int)viewCells.size());
 
@@ -847,9 +845,9 @@
 	char s[64]; 
 
-	mEnvironment->GetIntValue("ViewCells.Evaluation.samplesPerPass", samplesPerPass);
-	mEnvironment->GetIntValue("ViewCells.Evaluation.samples", numSamples);
+	Environment::GetSingleton()->GetIntValue("ViewCells.Evaluation.samplesPerPass", samplesPerPass);
+	Environment::GetSingleton()->GetIntValue("ViewCells.Evaluation.samples", numSamples);
 
 	char statsPrefix[100];
-	mEnvironment->GetStringValue("ViewCells.Evaluation.statsPrefix", statsPrefix);
+	Environment::GetSingleton()->GetStringValue("ViewCells.Evaluation.statsPrefix", statsPrefix);
 
 	Debug << "view cell evaluation samples per pass: " << samplesPerPass << endl;
@@ -895,17 +893,33 @@
 				 		Preprocessor::SPATIAL_BOX_BASED_DISTRIBUTION;
 		*/
+		long startTime = GetTime();
+
 		//-- construction rays => we use uniform samples for this
-		cout << "casting " << samplesPerPass << " samples " << endl;
+		cout << "casting " << samplesPerPass << " samples ... ";
+		Debug << "casting " << samplesPerPass << " samples ... ";
+
 		CastPassSamples(samplesPerPass, samplingType, evaluationSamples);
 		
 		castSamples += samplesPerPass;
 
-		cout << "computing sample contributions of " << (int)evaluationSamples.size() 
-			 << " samples " << endl;
+		Real timeDiff = TimeDiff(startTime, GetTime());
+		Debug << "finished in " << timeDiff * 1e-3 << " secs" << endl;
+		cout << "finished in " << timeDiff * 1e-3 << " secs" << endl;
+
+		cout << "computing sample contributions of " << (int)evaluationSamples.size()  << " samples ... ";
+		Debug << "computing sample contributions of " << (int)evaluationSamples.size()  << " samples ... ";
+
+		startTime = GetTime();
 
 		ComputeSampleContributions(evaluationSamples, true, false);
 
+		timeDiff = TimeDiff(startTime, GetTime());
+		cout << "finished in " << timeDiff * 1e-3 << " secs" << endl;
+		Debug << "finished in " << timeDiff * 1e-3 << " secs" << endl;
+
+		startTime = GetTime();
+
 		cout << "compute new statistics ... ";
-
+		Debug << "compute new statistics ... ";
 
 		//-- propagate pvs or pvs size information
@@ -913,5 +927,4 @@
 		UpdatePvsForEvaluation(mViewCellsTree->GetRoot(), pvs);
 
-
 		//-- output stats
 		sprintf(s, "-%09d-eval.log", castSamples);
@@ -920,5 +933,8 @@
 		mViewCellsTree->ExportStats(fileName);
 
-		cout << "finished" << endl;
+		timeDiff = TimeDiff(startTime, GetTime());
+		cout << "finished in " << timeDiff * 1e-3 << " secs" << endl;
+		Debug << "finished in " << timeDiff * 1e-3 << " secs" << endl;
+
 	
 		disposeRays(evaluationSamples, NULL);
@@ -931,6 +947,6 @@
 	int histoStepSize;
 
-	mEnvironment->GetBoolValue("ViewCells.Evaluation.histogram", useHisto);
-	mEnvironment->GetIntValue("ViewCells.Evaluation.histoStepSize", histoStepSize);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.Evaluation.histogram", useHisto);
+	Environment::GetSingleton()->GetIntValue("ViewCells.Evaluation.histoStepSize", histoStepSize);
 
 	const int numLeaves = mViewCellsTree->GetNumInitialViewCells(mViewCellsTree->GetRoot());
@@ -1263,5 +1279,5 @@
 	X3dParser parser;
 
-	mEnvironment->GetFloatValue("ViewCells.height", parser.mViewCellHeight);
+	Environment::GetSingleton()->GetFloatValue("ViewCells.height", parser.mViewCellHeight);
 
 	bool success = parser.ParseFile(filename, *this);
@@ -1705,10 +1721,10 @@
 	float pos;
 
-	mEnvironment->GetFloatValue("ViewCells.Visualization.clipPlanePos", pos);
+	Environment::GetSingleton()->GetFloatValue("ViewCells.Visualization.clipPlanePos", pos);
 
 	Vector3 point = mViewSpaceBox.Min() +  mViewSpaceBox.Size() * pos;
 
 	if (mUseClipPlaneForViz)
-        mEnvironment->GetIntValue("ViewCells.Visualization.clipPlaneAxis", axis);
+        Environment::GetSingleton()->GetIntValue("ViewCells.Visualization.clipPlaneAxis", axis);
 
 	Vector3 normal(0,0,0);
@@ -2169,8 +2185,8 @@
 
 
-BspViewCellsManager::BspViewCellsManager(BspTree *bspTree, Environment *env):
-ViewCellsManager(env), mBspTree(bspTree)
-{
-	mEnvironment->GetIntValue("BspTree.Construction.samples", mInitialSamples);
+BspViewCellsManager::BspViewCellsManager(BspTree *bspTree):
+ViewCellsManager(), mBspTree(bspTree)
+{
+	Environment::GetSingleton()->GetIntValue("BspTree.Construction.samples", mInitialSamples);
 	mBspTree->SetViewCellsManager(this);
 	mBspTree->mViewCellsTree = mViewCellsTree;
@@ -2340,5 +2356,5 @@
 	{
 		char mstats[100];
-		mEnvironment->GetStringValue("ViewCells.mergeStats", mstats);
+		Environment::GetSingleton()->GetStringValue("ViewCells.mergeStats", mstats);
 		mViewCellsTree->ExportStats(mstats);
 	}
@@ -2424,5 +2440,5 @@
 	{
 		char filename[100];
-		mEnvironment->GetStringValue("ViewCells.filename", filename);
+		Environment::GetSingleton()->GetStringValue("ViewCells.filename", filename);
 		ExportViewCells(filename, mExportPvs, objects);
 	}
@@ -2432,5 +2448,5 @@
 	{
 		char filename[100];
-		mEnvironment->GetStringValue("ViewCells.boxesFilename", filename);
+		Environment::GetSingleton()->GetStringValue("ViewCells.boxesFilename", filename);
 		ExportBoundingBoxes(filename, objects);
 	}
@@ -2459,5 +2475,4 @@
 	
 	int savedColorCode = mColorCode;
-
 	
 	
@@ -2477,5 +2492,4 @@
 				exporter->ExportGeometry(objects);
 
-			//exporter->SetWireframe();
 			//exporter->SetFilled();
 			bool b = mUseClipPlaneForViz;
@@ -2492,5 +2506,5 @@
 	//-- visualization of the BSP splits
 	bool exportSplits = false;
-	mEnvironment->GetBoolValue("BspTree.Visualization.exportSplits", exportSplits);
+	Environment::GetSingleton()->GetBoolValue("BspTree.Visualization.exportSplits", exportSplits);
 
 	if (exportSplits)
@@ -3034,6 +3048,6 @@
 
 
-KdViewCellsManager::KdViewCellsManager(KdTree *kdTree, Environment *env):
-ViewCellsManager(env), mKdTree(kdTree), mKdPvsDepth(100)
+KdViewCellsManager::KdViewCellsManager(KdTree *kdTree):
+ViewCellsManager(), mKdTree(kdTree), mKdPvsDepth(100)
 {
 }
@@ -3338,8 +3352,8 @@
 
 
-VspKdViewCellsManager::VspKdViewCellsManager(VspKdTree *vspKdTree, Environment *env):
-ViewCellsManager(env), mVspKdTree(vspKdTree)
-{
-	mEnvironment->GetIntValue("VspKdTree.Construction.samples", mInitialSamples);
+VspKdViewCellsManager::VspKdViewCellsManager(VspKdTree *vspKdTree):
+ViewCellsManager(), mVspKdTree(vspKdTree)
+{
+	Environment::GetSingleton()->GetIntValue("VspKdTree.Construction.samples", mInitialSamples);
 	mVspKdTree->SetViewCellsManager(this);
 }
@@ -3699,8 +3713,8 @@
 
 
-VspBspViewCellsManager::VspBspViewCellsManager(VspBspTree *vspBspTree, Environment *env):
-ViewCellsManager(env), mVspBspTree(vspBspTree)
-{
-	mEnvironment->GetIntValue("VspBspTree.Construction.samples", mInitialSamples);
+VspBspViewCellsManager::VspBspViewCellsManager(VspBspTree *vspBspTree):
+ViewCellsManager(), mVspBspTree(vspBspTree)
+{
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Construction.samples", mInitialSamples);
 	mVspBspTree->SetViewCellsManager(this);
 	mVspBspTree->mViewCellsTree = mViewCellsTree;
@@ -3857,5 +3871,5 @@
 		ObjectPvs pvs;
 
-		mEnvironment->GetStringValue("ViewCells.mergeStats", mstats);
+		Environment::GetSingleton()->GetStringValue("ViewCells.mergeStats", mstats);
 		mViewCellsTree->ExportStats(mstats);
 	}
@@ -4111,5 +4125,5 @@
 	{
 		char filename[100];
-		mEnvironment->GetStringValue("ViewCells.filename", filename);
+		Environment::GetSingleton()->GetStringValue("ViewCells.filename", filename);
 		ExportViewCells(filename, mExportPvs, objects);
 	}
@@ -4120,26 +4134,7 @@
 	{
 		char filename[100];
-		mEnvironment->GetStringValue("ViewCells.boxesFilename", filename);
+		Environment::GetSingleton()->GetStringValue("ViewCells.boxesFilename", filename);
 	
 		ExportBoundingBoxes(filename, objects);
-/*
-		IndexedBoundingBoxContainer boxes;
-		LoadBoundingBoxes(filename, boxes);
-
-		IndexedBoundingBoxContainer::const_iterator it, it_end = boxes.end();
-
-		for (it = boxes.begin(); it != it_end; ++ it)
-		{
-			IndexedBoundingBox ibox = *it;
-			AxisAlignedBox3 box = ibox.second;
-
-			Debug << ibox.first << " " 
-				  << box.Min().x << " " 
-				  << box.Min().y << " " 
-				  << box.Min().z << " " 
-				  << box.Max().x << " " 
-				  << box.Max().y << " " 
-                  << box.Max().z << endl;	
-		}*/
 	}
 
@@ -4330,4 +4325,5 @@
 			if (0)
 			{
+				// export view space box
 				exporter->SetWireframe();
 				exporter->ExportBox(mViewSpaceBox);
@@ -4421,5 +4417,5 @@
 	//-- visualization of the BSP splits
 	bool exportSplits = false;
-	mEnvironment->GetBoolValue("VspBspTree.Visualization.exportSplits", exportSplits);
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.Visualization.exportSplits", exportSplits);
 
 	if (exportSplits)
@@ -4712,5 +4708,5 @@
 	int numSamples;
 
-	mEnvironment->GetIntValue("RenderSampler.samples", numSamples);
+	Environment::GetSingleton()->GetIntValue("RenderSampler.samples", numSamples);
 	cout << "samples" << numSamples << endl;
 
@@ -5046,5 +5042,5 @@
 	int i;
 	for (i=0; it != it_end; ++ it, ++ i) {
-	  	cout<<"v"<<i<<" pvs="<<(*it)->GetPvs().mEntries.size()<<endl;
+	  	//cout<<"v"<<i<<" pvs="<<(*it)->GetPvs().mEntries.size()<<endl;
 	  pvs.Merge((*it)->GetPvs());
 	}
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 1004)
@@ -86,5 +86,5 @@
   mFrame = 0;
   mWireFrame = false;
-  environment->GetBoolValue("Preprocessor.detectEmptyViewSpace", mDetectEmptyViewSpace);
+  Environment::GetSingleton()->GetBoolValue("Preprocessor.detectEmptyViewSpace", mDetectEmptyViewSpace);
   mSnapErrorFrames = true;
   mSnapPrefix = "snap/";
@@ -775,5 +775,5 @@
 QGLPixelBuffer(QSize(w, h)), GlRenderer(sceneGraph, viewcells, tree) {
  
-  environment->GetIntValue("Preprocessor.pvsRenderErrorSamples", mPvsStatFrames);
+  Environment::GetSingleton()->GetIntValue("Preprocessor.pvsRenderErrorSamples", mPvsStatFrames);
   mPvsErrorBuffer.resize(mPvsStatFrames);
   ClearErrorBuffer();
@@ -939,8 +939,8 @@
 
 void
-GlRendererWidget::SetupProjection(const int w, const int h)
+GlRendererWidget::SetupProjection(const int w, const int h, const float angle)
 {
   if (!mTopView)
-	GlRenderer::SetupProjection(w, h);
+	GlRenderer::SetupProjection(w, h, angle);
   else {
 	glViewport(0, 0, w, h);
